/**
	$Id: StartServiceRenderer.java 4512 2008-09-11 20:05:50Z jari $

	Copyright (C) 2008 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.clients.web.extensions.service;

import net.sf.basedb.util.extensions.Renderer;

/**
	A renderer that starts the the service of a
	{@link ServiceControllerAction}.

	@author nicklas
	@version 2.8
	@base.modified $Date: 2008-09-11 22:05:50 +0200 (Thu, 11 Sep 2008) $
*/
public class StartServiceRenderer
	implements Renderer<ServiceControllerAction>
{
	private static final org.apache.log4j.Logger log = 
		org.apache.log4j.LogManager.getLogger("net.sf.basedb.clients.web.extensions.service.StartServiceRenderer");

	public StartServiceRenderer()
	{}
	
	/**
		Calls {@link ServiceControllerAction#start()} on the <code>service</code>.
	*/
	@Override
	public void render(ServiceControllerAction service)
	{
		log.info("Starting service: " + service);
		service.start();
		log.info("Starting service done: " + service);
	}

}
