<%-- $Id: view_plate.jsp 5062 2009-08-19 09:35:32Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Hkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Group"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.AnnotationSet"
	import="net.sf.basedb.core.Plate"
	import="net.sf.basedb.core.PlateType"
	import="net.sf.basedb.core.PlateGeometry"
	import="net.sf.basedb.core.PlateMapping"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.ItemResultIterator"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.MultiPermissions"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.ChangeHistoryUtil"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.Collections"
	import="java.util.Date"
	import="java.util.Map"
	import="java.util.Set"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.PLATE;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.ITEM);
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String tab = Values.getString(request.getParameter("tab"), "properties");
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);

	String title = null;
	Plate plate = Plate.getById(dc, itemId);
	
	PlateMapping currentPlateMapping = null;
	try
	{
		currentPlateMapping = plate.getPlateMapping();
	}
	catch (PermissionDeniedException ex)
	{}
	
	final boolean writePermission = plate.hasPermission(Permission.WRITE);
	final boolean deletePermission = plate.hasPermission(Permission.DELETE);
	final boolean sharePermission = plate.hasPermission(Permission.SET_PERMISSION);
	final boolean setOwnerPermission = plate.hasPermission(Permission.SET_OWNER);
	final boolean isRemoved = plate.isRemoved();
	final boolean isUsed = isRemoved && plate.isUsed();
	final boolean deletePermanentlyPermission = deletePermission && !isUsed;
	final boolean isOwner = plate.isOwner();
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, guiContext, plate);
	ExtensionsInvoker invoker = ToolbarUtil.useExtensions(jspContext);
	%>
	<base:page title="<%=title%>">
	<base:head scripts="tabcontrol.js,table.js" styles="toolbar.css,table.css,headertabcontrol.css,path.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		function editItem()
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>, true);
		}
		function shareItem()
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd=ShareItem&item_id=<%=itemId%>', 'SharePlate', 600, 400);
		}
		function deleteItem()
		{
			location.replace('index.jsp?ID=<%=ID%>&cmd=DeleteItem&item_id=<%=itemId%>');
		}
		function restoreItem()
		{
			location.replace('index.jsp?ID=<%=ID%>&cmd=RestoreItem&item_id=<%=itemId%>');
		}
		function deleteItemPermanently()
		{
			Main.deleteItemPermanently('<%=ID%>', true, '<%=itemType.name()%>', <%=itemId%>, '&callback=itemDeleted');
		}
		function itemDeleted()
		{
			Main.listItems('<%=ID%>', '<%=itemType.name()%>');
		}
		function showUsingItems()
		{
			Main.showUsingItems('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>);
		}
		function setOwner()
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd=SetOwnerOfItem&item_id=<%=itemId%>', 'SetOwnerOfItem', 450, 150);
		}
		function runPlugin(cmd)
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd='+cmd+'&item_id=<%=itemId%>', 'RunPlugin'+cmd, 740, 540);
		}
		function viewWells()
		{
			location.href = 'wells/index.jsp?ID=<%=ID%>&plate_id=<%=itemId%>';
		}
		function viewEvents()
		{
			location.href = 'events/index.jsp?ID=<%=ID%>&plate_id=<%=itemId%>';
		}
		function switchTab(tabControlId, tabId)
		{
			if (tabId == 'history' && tabId != '<%=tab%>')
			{
				location.href = 'index.jsp?ID=<%=ID%>&cmd=ViewItem&item_id=<%=itemId%>&tab='+tabId;
			} 
			else if (tabId == 'events')
			{
				viewEvents();
			}
			else if (tabId == 'wells')
			{
				viewWells();
			}
			else
			{
				TabControl.setActiveTab(tabControlId, tabId);
			}
		}
		</script>
	</base:head>
	<base:body>
		<p>
		<p:path>
			<p:pathelement title="Plates" href="<%="index.jsp?ID="+ID%>" />
			<p:pathelement title="<%=HTML.encodeTags(plate.getName())%>" />
		</p:path>
		
		<t:tabcontrol id="main" active="<%=tab%>" switch="switchTab" remember="false">
		<t:tab id="properties" title="Properties">
		<tbl:toolbar
			>
			<tbl:button 
				disabled="<%=writePermission ? false : true%>" 
				image="<%=writePermission ? "edit.gif" : "edit_disabled.gif"%>" 
				onclick="editItem()" 
				title="Edit&hellip;" 
				tooltip="<%=writePermission ? "Edit this plate" : "You do not have permission to edit this plate"%>" 
			/>
			<tbl:button 
				disabled="<%=deletePermission ? false : true%>" 
				image="<%=deletePermission ? "delete.gif" : "delete_disabled.gif"%>" 
				onclick="deleteItem()" 
				title="Delete"
				visible="<%=!plate.isRemoved()%>"
				tooltip="<%=deletePermission ? "Delete this plate" : "You do not have permission to delete this plate"%>" 
			/>
			<tbl:button 
				disabled="<%=writePermission ? false : true%>" 
				image="<%=writePermission ? "restore.gif" : "restore_disabled.gif"%>" 
				onclick="restoreItem()" 
				title="Restore"
				visible="<%=plate.isRemoved()%>"
				tooltip="<%=writePermission ? "Restore this plate" : "You do not have permission to restore this plate"%>" 
			/>
			<tbl:button 
				disabled="<%=sharePermission ? false : true%>"
				image="<%=sharePermission ? "share.gif" : "share_disabled.gif"%>"
				onclick="shareItem()" 
				title="Share&hellip;" 
				tooltip="<%=sharePermission ? "Share this plate to other user, groups and projects" : "You do not have permission to share this plate"%>"
			/>
			<tbl:button 
				disabled="<%=setOwnerPermission ? false : true%>"
				image="<%=setOwnerPermission ? "take_ownership.png" : "take_ownership_disabled.png"%>"
				onclick="setOwner()" 
				title="Set owner&hellip;"
				tooltip="<%=setOwnerPermission ? "Change owner of this item" : "You do not have permission to change ownership of this item"%>"
			/>
			<tbl:button 
				image="import.gif" 
				onclick="runPlugin('ImportItem')" 
				title="Import&hellip;" 
				tooltip="Import data" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
			/>
			<tbl:button 
				image="export.gif" 
				onclick="runPlugin('ExportItem')" 
				title="Export&hellip;" 
				tooltip="Export data" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
			/>
			<tbl:button 
				image="runplugin.gif" 
				onclick="runPlugin('RunPlugin')" 
				title="Run plugin&hellip;" 
				tooltip="Run a plugin" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
			/>
			<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
				wrapper="<%=new PrefixSuffixRenderer(jspContext, "<td>", "</td>") %>"/>
			<tbl:button
				image="help.gif"
				onclick="<%="Main.openHelp('" + ID +"', 'plate.view.properties')"%>"
				title="Help&hellip;"
				tooltip="Get help about this page"
			/>
			</tbl:toolbar>
		<div class="boxedbottom">
			<div class="itemstatus">Permissions on this item: <i><%=PermissionUtil.getFullPermissionNames(plate)%></i></div>
			<%
			if (plate.isRemoved() || plate.isShared())
			{
				%>
				<div class="itemstatus">
					<base:icon 
						image="<%=deletePermanentlyPermission ? "deleted.gif" : "deleted_disabled.gif"%>"
						onclick="<%=deletePermanentlyPermission ? "deleteItemPermanently()" : null%>"
						tooltip="<%=deletePermanentlyPermission ? "Permanently delete this item" : null%>"
						visible="<%=isRemoved%>"> This item has been flagged for deletion<br></base:icon>
					<base:icon image="used.gif" 
						onclick="showUsingItems()"
						tooltip="Show the items that are using this one"
						visible="<%=isUsed%>"> This item is used by other items and can't be permanently deleted<br></base:icon>
					<base:icon image="shared.gif" 
						visible="<%=plate.isShared()%>"> This item is shared to other users, groups and/or projects</base:icon>
				</div>
				<%
			}
			%>
			<table class="form" cellspacing="0">
			<tr>
				<td class="prompt">Name</td>
				<td><%=HTML.encodeTags(plate.getName())%></td>
			</tr>
			<tr>
				<td class="prompt">Registered</td>
				<td><%=dateFormatter.format(plate.getEntryDate())%></td>
			</tr>
			<tr>
				<td class="prompt">Barcode</td>
				<td><%=HTML.encodeTags(plate.getBarcode())%></td>
			</tr>
			<tr>
				<td class="prompt">Destroyed</td>
				<td><%=plate.isDestroyed() ? "yes" : "no"%></td>
			</tr>
			<tr>
				<td class="prompt">Type</td>
				<td><base:propertyvalue item="<%=plate%>" property="plateType" /></td>
			</tr>
			<tr>
				<td class="prompt">Geometry</td>
				<td><base:propertyvalue item="<%=plate%>" property="plateType.plateGeometry" /></td>
			</tr>
			<tr valign="baseline">
				<td class="prompt">Merge mapping</td>
				<td><%
					if (currentPlateMapping != null && currentPlateMapping.getImage() != null)
					{
						%>
						<img id="mappingImage" src="../../images/platemappings/<%=currentPlateMapping.getImage()%>" align="right">
						<%
					}
					%>
					<base:propertyvalue item="<%=plate%>" property="plateMapping" />
				</td>
			</tr>
			<tr>
				<td class="prompt">Owner</td>
				<td><base:propertyvalue item="<%=plate%>" property="owner" /></td>
			</tr>
			<tr>
				<td class="prompt">Description</td>
				<td><%=HTML.niceFormat(plate.getDescription())%></td>
			</tr>
			</table>
			
			<%
			ItemQuery<Plate> parentPlatesQuery = plate.getParentPlates();
			parentPlatesQuery.include(Include.ALL);
			parentPlatesQuery.order(Orders.asc(Hql.property("name")));
			ItemResultList<Plate> parentPlates = parentPlatesQuery.list(dc);
			if (parentPlates.size() == 0)
			{
				%>
				<h4>Parent plates</h4>
				This plate doesn't have any parents (or, you don't have permission to view them).
				<%
			}
			else
			{
				%>
				<base:section
					id="parents"
					title="<%="Parent plates (" + parentPlates.size() + ")"%>"
					context="<%=cc%>"
					>
					<tbl:table
						id="parentplates"
						clazz="itemlist"
						columns="all"
						>
					<tbl:columndef 
						id="name"
						title="Name"
					/>
					<tbl:columndef 
						id="index"
						title="Index"
					/>
					<tbl:columndef 
						id="description"
						title="Description"
					/>
					<tbl:data>
						<tbl:columns>
						</tbl:columns>
						<tbl:rows>
						<%
						for (Plate item : parentPlates)
						{
							%>
							<tbl:row>
								<tbl:cell column="name"><base:icon 
										image="deleted.gif" 
										tooltip="This item has been scheduled for deletion" 
										visible="<%=item.isRemoved()%>"
									/><%=Base.getLinkedName(ID, item, false, true)%></tbl:cell>
								<tbl:cell column="index"><%=plate.getSourceIndex(item)+1%></tbl:cell>
								<tbl:cell column="description"><%=HTML.encodeTags(item.getDescription())%></tbl:cell>
							</tbl:row>
							<%
						}
						%>
						</tbl:rows>
					</tbl:data>
					</tbl:table>
				</base:section>
				<%
			}
			%>
			<%
			ItemQuery<Plate> childPlatesQuery = plate.getChildPlates();
			childPlatesQuery.include(Include.ALL);
			childPlatesQuery.order(Orders.asc(Hql.property("name")));
			ItemResultList<Plate> childPlates = childPlatesQuery.list(dc);
			if (childPlates.size() == 0)
			{
				%>
				<h4>Child plates</h4>
				This plate doesn't have any children (or, you don't have permission to view them).
				<%
			}
			else
			{
				%>
				<base:section
					id="children"
					title="<%="Child plates (" + childPlates.size() + ")"%>"
					context="<%=cc%>"
					>
					<tbl:table
						id="childplates"
						clazz="itemlist"
						columns="all"
						>
					<tbl:columndef 
						id="name"
						title="Name"
					/>
					<tbl:columndef
						id="mapping"
						title="Mapping"
					/>
					<tbl:columndef 
						id="index"
						title="Index"
					/>
					<tbl:columndef 
						id="description"
						title="Description"
					/>
					<tbl:data>
						<tbl:columns>
						</tbl:columns>
						<tbl:rows>
						<%
						for (Plate item : childPlates)
						{
							%>
							<tbl:row>
								<tbl:cell column="name"><base:icon 
										image="deleted.gif" 
										tooltip="This item has been scheduled for deletion" 
										visible="<%=item.isRemoved()%>"
									/><%=Base.getLinkedName(ID, item, false, true)%></tbl:cell>
								<tbl:cell column="mapping"><base:propertyvalue item="<%=item%>" property="plateMapping" /></tbl:cell>
								<tbl:cell column="index"><%=item.getSourceIndex(plate) + 1%></tbl:cell>
								<tbl:cell column="description"><%=HTML.encodeTags(item.getDescription())%></tbl:cell>
							</tbl:row>
							<%
						}
						%>
						</tbl:rows>
					</tbl:data>
					</tbl:table>
				</base:section>
				<%
			}			
			
			// Tables with users/groups/projects that this item is shared to
			MultiPermissions mp = new MultiPermissions(Collections.singleton(plate));
			ItemResultList<User> users = mp.getUsers().list(dc);
			ItemResultList<Group> groups = mp.getGroups().list(dc);
			ItemResultList<Project> projects = mp.getProjects().list(dc);
			int totalShare = users.size() + groups.size() + projects.size();
			
			if (totalShare > 0)
			{
				%>
				<base:section
					id="sharedTo"
					title="<%="Shared to (" + totalShare + ")"%>"
					context="<%=cc%>"
					>
					<tbl:table 
						id="itemsSharedTo"
						clazz="itemlist"
						columns="all"
					>
						<tbl:columndef 
							id="itemType"
							title="Item type"
						/>
						<tbl:columndef 
							id="name"
							title="Name"
						/>
						<tbl:columndef 
							id="permissions"
							title="Permissions"
						/>
						<tbl:data>
							<tbl:columns>
							</tbl:columns>
							<tbl:rows>
							<%
							for (Project project : projects)								
							{
								Set<Permission> permissions = mp.getPermissions(project).values().iterator().next();
								%>			
								<tbl:row>
									<tbl:cell column="itemType"><%=project.getType()%></tbl:cell>
									<tbl:cell column="name"><base:icon 
										image="deleted.gif" 
										tooltip="This item has been scheduled for deletion" 
										visible="<%=project.isRemoved()%>"
									/><%=Base.getLinkedName(ID, project, false, true)%></tbl:cell>
									<tbl:cell column="permissions">
										<%=PermissionUtil.translatePermissionsToString(permissions)%>
									</tbl:cell>
								</tbl:row>
								<%
							}
							for (Group group : groups)
							{
								Set<Permission> permissions = mp.getPermissions(group).values().iterator().next();
								%>
								<tbl:row>							
									<tbl:cell column="itemType"><%=group.getType()%></tbl:cell>
									<tbl:cell column="name"><base:icon 
										image="deleted.gif" 
										tooltip="This item has been scheduled for deletion" 
										visible="<%=group.isRemoved()%>"
									/><%=Base.getLinkedName(ID, group, false, true)%></tbl:cell>
									<tbl:cell column="permissions">
										<%=PermissionUtil.translatePermissionsToString(permissions)%>
									</tbl:cell>
								</tbl:row>
								<%	
							}
							for (User user : users)
							{
								Set<Permission> permissions = mp.getPermissions(user).values().iterator().next();
								%>
								<tbl:row>							
									<tbl:cell column="itemType"><%=user.getType()%></tbl:cell>
									<tbl:cell column="name"><base:icon 
										image="deleted.gif" 
										tooltip="This item has been scheduled for deletion" 
										visible="<%=user.isRemoved()%>"
									/><%=Base.getLinkedName(ID, user, false, true)%></tbl:cell>
									<tbl:cell column="permissions">
										<%=PermissionUtil.translatePermissionsToString(permissions)%>
									</tbl:cell>
								</tbl:row>
								<%
							}
							%>
							</tbl:rows>
						</tbl:data>
					</tbl:table>
				</base:section>
				<%
			}
			else
			{
				%>
				<h4>Shared to</h4>
				This plate is not shared 
				(or, you don't have permission to view the ones it is shared to).
				<%
			}
			%>


		</div>
			</t:tab>
			
			<t:tab id="annotations" title="Annotations" >
				<div class="boxed">
				<jsp:include page="../../common/annotations/list_annotations.jsp">
					<jsp:param name="item_type" value="<%=itemType.name()%>" />
					<jsp:param name="item_id" value="<%=itemId%>" />
					<jsp:param name="ID" value="<%=ID%>" />
				</jsp:include>
				</div>
			</t:tab>
			
			<t:tab id="events" title="Events" />
			<t:tab id="wells" title="Wells" />
			<t:tab id="history" title="Change history" 
				tooltip="Displays a log of all modifications made to this item"
				visible="<%=ChangeHistoryUtil.showChangeHistoryTab(sc)%>">
				<%
				if ("history".equals(tab))
				{
					%>
					<jsp:include page="../../common/history/frameset.jsp">
						<jsp:param name="source_type" value="<%=itemType.name()%>" />
						<jsp:param name="source_id" value="<%=itemId%>" />
						<jsp:param name="ID" value="<%=ID%>" />
					</jsp:include>
					<%
				}
				%>
			</t:tab>
			</t:tabcontrol>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}

%>
